<dom-module id="chat-message">
    <template>
      <style>
        :host { display: block;}
        .container {
          border: 2px solid #dedede;
          background-color: #f1f1f1;
          border-radius: 5px;
          padding: 10px;
          margin: 10px;
          width: 80%;
        }
        .darker { border-color: #ccc; background-color: #ddd; margin-left:auto; margin-right:0; }
        .container::after { content: ""; clear: both; display: table; }
        .container img {
          float: left;
          max-width: 40px;
          width: 100%;
          margin-right: 20px;
          border-radius: 50%;
        }
        .container img.right { float: right; margin-left: 20px; margin-right:0; }
        .time-right { float: right; color: #aaa; font-size: .7rem; }
        .p-right { text-align: right; }
        .time-left { float: left; color: rgb(78, 77, 77); font-size: .7rem; }
      </style>
      <template is="dom-repeat" items="[[messages]]">
        <template is="dom-if" if="[[item.isAdmon]]">
          <div class="container">
            <img src="http://www.ferretornillosdesilao.com/wp-content/uploads/2015/03/favicon.png" alt="Avatar">
            <p class="p-right">[[item.message]]</p>
            <span class="time-right">[[_calDate(item.date)]]</span>
          </div>
        </template>
        <template is="dom-if" if="[[!item.isAdmon]]">
          <div class="container darker">
            <img src="https://tnckb94959.i.lithium.com/skins/images/3AB578B02FD7B257A7B52D5E05139FE9/atlassian_community/images/icon_anonymous_profile.png" alt="Avatar" class="right">
            <p>[[item.message]]</p>
            <span class="time-left">[[_calDate(item.date)]]</span>
          </div>
        </template>
      </template>
    </template>
  
    <script>
      class ChatMessage extends Polymer.Element {
        static get is() { return 'chat-message' }
        static get properties() { 
          return {
            messages: Array,
            days: { 
              type: Array, 
              value: ['0', '01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31'] 
            },
            months: { 
              type: Array, 
              value: ['ene','feb','mar','abr','may','jun','jul','ago','sep','oct','nov','dic'] 
            }
          } 
        }
  
        static get observers() { return [ '_obsMessages(messages.*)' ] }
        
        _obsMessages() {
          if(this.message != null && this.message.length) {
            let that = this;
            setTimeout(function(){ 
              that.shadowRoot.querySelector('#container-chat').scrollTop = that.shadowRoot.querySelector('#container-chat').scrollHeight + 150; 
            }, 500);
          }
        }

        _calDate(d) {
          let date = new Date(d);
          return this.days[date.getDate()] + '/' + this.months[date.getMonth()] + '/' + date.getFullYear() + ' ' + this.days[date.getHours()] + ':' + date.getMinutes();
        }

      }
      window.customElements.define(ChatMessage.is, ChatMessage);
    </script>
  </dom-module>
  